from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.property_ import Property


T = TypeVar("T", bound="QueryCollaboratorBodySelectItem")


@_attrs_define
class QueryCollaboratorBodySelectItem:
    """
    Attributes:
        property_ (Property):
        alias (Union[Unset, str]):
    """

    property_: "Property"
    alias: Union[Unset, str] = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        property_ = self.property_.to_dict()

        alias = self.alias

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "property": property_,
            }
        )
        if alias is not UNSET:
            field_dict["alias"] = alias

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.property_ import Property

        d = dict(src_dict)
        property_ = Property.from_dict(d.pop("property"))

        alias = d.pop("alias", UNSET)

        query_collaborator_body_select_item = cls(
            property_=property_,
            alias=alias,
        )

        query_collaborator_body_select_item.additional_properties = d
        return query_collaborator_body_select_item

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
